<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xmleye="http://www.uca.es/xmleye">

<!-- Orden igual al del XML original, sin podado -->

<xsl:template match="/">
  <xsl:apply-templates select="." mode="process-node"/>
</xsl:template>

<!-- Evitamos la duplicación de información que causaría la regla por defecto -->
<xsl:template match="*" />

<xsl:template match="*" mode="process-node">
  <xsl:element name="{name(.)}">
    <xsl:copy-of select="@*"/>
    <xsl:attribute name="UID"><xsl:value-of select="generate-id()"/></xsl:attribute>
    <xsl:apply-templates select="."/>
    <xsl:copy-of select="text()"/>
    <xsl:apply-templates select="." mode="process-children"/>
  </xsl:element>
</xsl:template>

<xsl:template match="*" mode="process-children">
  <xsl:apply-templates select="*" mode="process-node"/>
</xsl:template>

</xsl:stylesheet>